<?php

/**
 * tercero_du actions.
 *
 * @package    cartera
 * @subpackage tercero_du
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class tercero_duActions extends sfAPIActions {
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */

    protected $id_name = 'id_mt_ubi'; //identificador de la tabla
    protected $id_names = array('id_mt_ubi'); //llave primaria
    protected $field_names = array('id_mae_ter', 'id_pais', 'ciudad', 'copdepto', 'mail'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'INTERCER_DU'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = true; //si posee secuencia la tabla


    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_mt_ubi'; //identificador unico de la tabla

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */

    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {

            $id_mae_ter = $request['id_mae_ter'];

            $sql = <<<EOD
select count(*) cantidad from INTERCER_DU where id_mae_ter = $id_mae_ter
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $cantidad = $records[0]['cantidad'];
            if ($cantidad == 0) {

                $sql = <<<EOD
insert into intercer_du(ID_MAE_TER)
                           VALUES ($id_mae_ter)
EOD;

                CN_TABLE::executeSQL($sql);
            }

            $sql = <<<EOD
select max(id_mt_ubi) id_mt_ubi from INTERCER_DU where id_mae_ter = $id_mae_ter
EOD;

            $records = CN_TABLE::executeSQL($sql);


            $id_mt_ubi = $records[0]['id_mt_ubi'];

            $request['id_mt_ubi'] = $id_mt_ubi;
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {

            if (isset($request['tag_actualiza_pos'])) {

                //Actualizacion email, direccion y telefono - 20151023
                if ($request['tag_actualiza_pos'] == 1) {

                    $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
                    $this->conn->beginTransaction();
                    try {

                        $id_mt_ubi = $list_data_post[0]['id_mt_ubi'];
                        $telefono = $request['tel'];
                        $direccion = $request['direccion'];

                        $sql = <<<EOD
select count(*) cantidad from INTERCER_DU_DIR where id_mt_ubi = $id_mt_ubi
EOD;

                        $records = CN_TABLE::executeSQL($sql);

                        $cantidad = $records[0]['cantidad'];

                        if ($cantidad == 0) {

                            $sql = <<<EOD
insert into intercer_du_dir(ID_MT_UBI,ID_TIP_DIR,DIRECCION,TEL,ID_PAIS,CIUDAD,ESTADO,PRINCIPAL)
                            VALUES ($id_mt_ubi,5,'$direccion','$telefono',49,'null',1,1)
                           
EOD;

                            CN_TABLE::executeSQL($sql);
                        } else {

                            $sql = <<<EOD
select max(id_ubi_dir) id_ubi_dir from INTERCER_DU_DIR where id_mt_ubi = $id_mt_ubi
EOD;

                            $records = CN_TABLE::executeSQL($sql);


                            $id_ubi_dir = $records[0]['id_ubi_dir'];

                            $sql = <<<EOD
update intercer_du_dir set direccion = '$direccion', tel='$telefono' where id_ubi_dir = $id_ubi_dir
                           
EOD;

                            CN_TABLE::executeSQL($sql);
                        }



                        $this->conn->commit();
                    } catch (Exception $e) {

                        //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                        $this->conn->rollback();
                    }
                }
            }
        }




        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
